 /*
  * Khoros: $Id$
  */

 /*
  * $Log$
  */

/*
 * Copyright (C) 1993, 1994, 1995, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: This file contains the macro files for
   >>>>		       the different operating systems that Khoros
   >>>>		       has been ported to.
   >>>>
   >>>>    Written By: Mark Young, John Salas, Jeremy Worley
   >>>>
   >>>>          Date: Jul 16, 1994
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _machine_macro_h_
#define _machine_macro_h_

        /*-------------------------------------*
        |       #include 
        ---------------------------------------*/

/*
 *  We hope this will go away in the not so distant future.
 */
#include <machine/kopsys.h>
 
#include <stdio.h>
#include <setjmp.h>
#include <ctype.h>
#include <pwd.h>
#include <errno.h>
#include <string.h>
#include <fcntl.h>
#include <time.h>
#include <dirent.h>
#include <unistd.h>
#include <stddef.h>
#include <stdlib.h>
 
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/wait.h>


                     /* This one for OSF */
#if (KOPSYS_LOCAL == KOPSYS_OSF)
#include <machine/osf.h>
#endif

                     /* This one for AIX */
#if (KOPSYS_LOCAL == KOPSYS_AIX)
#include <machine/aix.h>
#endif

                     /* This one for HPUX */
#if (KOPSYS_LOCAL == KOPSYS_HPUX)
#include <machine/hpux.h>
#endif

                     /* This one for SUNOS */
#if (KOPSYS_LOCAL == KOPSYS_SUNOS)
#include <machine/sunos.h>
#endif

                     /* This one for SOLARIS */
#if (KOPSYS_LOCAL == KOPSYS_SOLARIS)
#include <machine/solaris.h>
#endif

                     /* This one for ULTRIX */
#if (KOPSYS_LOCAL == KOPSYS_ULTRIX)
#include <machine/ultrix.h>
#endif

                     /* This one for IRIX */
#if (KOPSYS_LOCAL == KOPSYS_IRIX)
#include <machine/irix.h>
#endif

                     /* This one for UNICOS */
#if (KOPSYS_LOCAL == KOPSYS_UNICOS)
#include <machine/unicos.h>
#endif

                     /* This one for DGUX */
#if (KOPSYS_LOCAL == KOPSYS_DGUX)
#include <machine/dgux.h>
#endif

                     /* This one for BSDI */
#if (KOPSYS_LOCAL == KOPSYS_BSDI)
#include <machine/bsdi.h>
#endif

                     /* This one for LINUX */
#if (KOPSYS_LOCAL == KOPSYS_LINUX)
#include <machine/linux.h>
#endif

                     /* This one for 386BSD */
#if (KOPSYS_LOCAL == KOPSYS_386BSD)
#include <machine/386bsd.h>
#endif

                     /* This one for NETBSD */
#if (KOPSYS_LOCAL == KOPSYS_NETBSD)
#include <machine/netbsd.h>
#endif

                     /* This one for FREEBSD */
#if (KOPSYS_LOCAL == KOPSYS_FREEBSD)
#include <machine/freebsd.h>
#endif

                     /* This one for INTERACTIVE */
#if (KOPSYS_LOCAL == KOPSYS_INTERACTIVE)
#include <machine/i386.h>
#endif

                     /* This one for CONVEX */
#if (KOPSYS_LOCAL == KOPSYS_CONVEX)
#include <machine/convex.h>
#endif

                     /* This one for SVR3 */
#if (KOPSYS_LOCAL == KOPSYS_SVR3)
#include <machine/svr3.h>
#endif

                     /* This one for NEXT */
#if (KOPSYS_LOCAL == KOPSYS_NEXT)
#include <machine/next.h>
#endif

                     /* This one for AUX */
#if (KOPSYS_LOCAL == KOPSYS_AUX)
#include <machine/aux.h>
#endif

                     /* This one for NEWSOS */
#if (KOPSYS_LOCAL == KOPSYS_NEWSOS)
#include <machine/newsos.h>
#endif

                     /* This one for LUNA */
#if (KOPSYS_LOCAL == KOPSYS_LUNA)
#include <machine/luna.h>
#endif

		     /* This one for Sequent Dynix/Ptx */
#if (KOPSYS_LOCAL == KOPSYS_DYNIX)
#include <machine/dynix.h>
#endif

        /*-------------------------------------*
        |       defines
        ---------------------------------------*/

#ifdef __GNUC__
#  define KASINH_DEF
#  define KACOSH_DEF
#  define KATANH_DEF
#  define KCBRT_DEF
#  define KHYPOT_DEF
#  define HAVE_NO_STRERROR
#endif


        /*-------------------------------------*
        |       typedefs
        ---------------------------------------*/

        /*-------------------------------------*
        |       global variable declarations
        ---------------------------------------*/

        /*-------------------------------------*
        |       routine definitions
        ---------------------------------------*/

#ifdef __GNUC__
double strtod PROTO((const char *, char **));
#endif


#endif /* _machine_macro_h_ */
/* Don't add after this point */
